using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;
using NUnit.Framework;

namespace Bug27453
{
    public partial class Form1 : Form
    {
        MySqlConnection conn = new MySqlConnection();
        DataTable data = new DataTable();
        MySqlDataAdapter da;
        MySqlCommandBuilder cb;

        public Form1()
        {
            InitializeComponent();
            conn.ConnectionString = "DataSource=localhost;Database=test;UserID=root;Password=;PORT=3306";
            conn.Open();
        }

        private void button1_Click(object sender, EventArgs e)
        {

            da = new MySqlDataAdapter("SELECT * FROM bug27453", conn);
            cb = new MySqlCommandBuilder(da);

            da.Fill(data);
            DataColumn[] PrimaryKeyColumns = new DataColumn[1];
            PrimaryKeyColumns[0] = data.Columns["id"];
            data.PrimaryKey = PrimaryKeyColumns;
            dataGridView1.DataSource = data;
            button2.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            button1.Enabled = false;
            try
            {
                da.Fill(data);

                DataRow row = data.NewRow();
                row["id"] = 1000;
                row["CharFld1"] = "Row 1 VCFld 1";
                row["CharFld2"] = DBNull.Value;
                row["CharFld3"] = DBNull.Value;
                row["CharFld4"] = "Row 1 VCFld 4";
                row["CharFld5"] = DBNull.Value;
                data.Rows.Add(row);
                da.Update(data);
                Assert.AreEqual(1, data.Rows.Count);

                row = data.NewRow();
                row["id"] = 1005;
                row["CharFld1"] = "Row 2 VCFld 1";
                row["CharFld2"] = DBNull.Value;
                row["CharFld3"] = "Row 2 VCFld 3";
                row["CharFld4"] = DBNull.Value;
                row["CharFld5"] = DBNull.Value;
                data.Rows.Add(row);
                da.Update(data);

                row = data.NewRow();
                row["id"] = 1010;
                row["CharFld1"] = "Row 3 VCFld 1";
                row["CharFld2"] = DBNull.Value;
                row["CharFld3"] = "Row 3 VCFld 3";
                row["CharFld4"] = DBNull.Value;
                row["CharFld5"] = DBNull.Value;
                data.Rows.Add(row);
                da.Update(data);

                row = data.NewRow();
                row["id"] = 1015;
                row["CharFld1"] = "Row 4 VCFld 1";
                row["CharFld2"] = DBNull.Value;
                row["CharFld3"] = DBNull.Value;
                row["CharFld4"] = "Row 4 VCFld 4";
                row["CharFld5"] = DBNull.Value;
                data.Rows.Add(row);
                da.Update(data);
            
            }
            catch (Exception ex)
            {
                Assert.Fail(ex.Message);
            }

        }
    }
}